=== debian/changelog ===
trantor (1.5.11+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1037487)
  * DS repack to get rid of the third_party directory

 -- Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>  Fri, 09 Jun 2023 18:41:52 +0200
