## trantor 1.5.12+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,12 +4,13 @@
 option(BUILD_DOC "Build Doxygen documentation" OFF)
 option(BUILD_C-ARES "Build C-ARES" ON)
 option(BUILD_SHARED_LIBS "Build trantor as a shared lib" OFF)
+option(TRANTOR_USE_TLS "TLS provider for trantor. Valid options are 'openssl', 'botan' or '' (let the build scripr decide)" "")
 
 list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)
 
 set(TRANTOR_MAJOR_VERSION 1)
 set(TRANTOR_MINOR_VERSION 5)
-set(TRANTOR_PATCH_VERSION 11)
+set(TRANTOR_PATCH_VERSION 12)
 set(TRANTOR_VERSION
     ${TRANTOR_MAJOR_VERSION}.${TRANTOR_MINOR_VERSION}.${TRANTOR_PATCH_VERSION})
 
@@ -123,15 +124,69 @@
       trantor/utils/WindowsSupport.h)
 endif(WIN32)
 
-find_package(OpenSSL)
-if(OpenSSL_FOUND)
-  target_link_libraries(${PROJECT_NAME} PRIVATE OpenSSL::SSL OpenSSL::Crypto)
-  
-  # To enable the acceptance of local issued certificates
-  # Add the flag: ALLOW_SELF_SIGNED_CERTS
-  # ONLY FOR TESTING PURPOSES
-  target_compile_definitions(${PROJECT_NAME} PRIVATE USE_OPENSSL)
-endif()
+# Somehow the default value of TRANTOR_USE_TLS is OFF
+if(TRANTOR_USE_TLS STREQUAL OFF)
+  set(TRANTOR_USE_TLS "")
+endif()
+set(VALID_TLS_PROVIDERS "openssl" "botan" "none")
+list(FIND VALID_TLS_PROVIDERS "${TRANTOR_USE_TLS}" PREFERED_TLS_IDX)
+if(PREFERED_TLS_IDX EQUAL -1 AND NOT TRANTOR_USE_TLS STREQUAL "")
+  message(FATAL_ERROR "Invalid TLS provider: ${TRANTOR_USE_TLS}\n"
+                      "Valid TLS providers are: ${VALID_TLS_PROVIDERS}")
+endif()
+
+set(TRANTOR_TLS_PROVIDER "None")
+if(TRANTOR_USE_TLS STREQUAL "openssl" OR TRANTOR_USE_TLS STREQUAL "")
+  find_package(OpenSSL)
+  if(OpenSSL_FOUND)
+    target_link_libraries(${PROJECT_NAME} PRIVATE OpenSSL::SSL OpenSSL::Crypto)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE USE_OPENSSL)
+    set(TRANTOR_TLS_PROVIDER "OpenSSL")
+
+    set(TRANTOR_SOURCES
+      ${TRANTOR_SOURCES}
+      trantor/net/inner/tlsprovider/OpenSSLProvider.cc
+      trantor/utils/crypto/openssl.cc)
+  elseif(TRANTOR_USE_TLS STREQUAL "openssl")
+    message(FATAL_ERROR "Requested OpenSSL TLS provider but OpenSSL was not found")
+  endif()
+endif()
+
+if(TRANTOR_TLS_PROVIDER STREQUAL "None"
+  AND (TRANTOR_USE_TLS STREQUAL "botan" OR TRANTOR_USE_TLS STREQUAL ""))
+  find_package(Botan)
+  if(Botan_FOUND)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE USE_BOTAN)
+    target_link_libraries(${PROJECT_NAME} PRIVATE Botan::Botan)
+    set(TRANTOR_TLS_PROVIDER "Botan")
+
+    set(TRANTOR_SOURCES
+        ${TRANTOR_SOURCES}
+        trantor/net/inner/tlsprovider/BotanTLSProvider.cc
+        trantor/utils/crypto/botan.cc)
+  elseif(TRANTOR_USE_TLS STREQUAL "botan")
+    message(FATAL_ERROR "Requested Botan TLS provider but Botan was not found")
+  endif()
+endif()
+
+if(TRANTOR_TLS_PROVIDER STREQUAL "None")
+  set(TRANTOR_SOURCES
+      ${TRANTOR_SOURCES}
+      trantor/utils/crypto/sha3.cc
+      trantor/utils/crypto/md5.cc
+      trantor/utils/crypto/sha1.cc
+      trantor/utils/crypto/sha256.cc
+      trantor/utils/crypto/blake2.cc)
+  set(private_headers
+      ${private_headers}
+      trantor/utils/crypto/sha3.h
+      trantor/utils/crypto/md5.h
+      trantor/utils/crypto/sha1.h
+      trantor/utils/crypto/sha256.h)
+endif()
+
+message(STATUS "Trantor using SSL library: ${TRANTOR_TLS_PROVIDER}")
+target_compile_definitions(${PROJECT_NAME} PRIVATE TRANTOR_TLS_PROVIDER=${TRANTOR_TLS_PROVIDER})
 
 set(HAVE_C-ARES NO)
 if (BUILD_C-ARES)
@@ -206,7 +261,9 @@
     trantor/net/TcpServer.h
     trantor/net/callbacks.h
     trantor/net/Resolver.h
-    trantor/net/Channel.h)
+    trantor/net/Channel.h
+    trantor/net/Certificate.h
+    trantor/net/TLSPolicy.h)
 
 set(public_utils_headers
     trantor/utils/AsyncFileLogger.h
@@ -274,6 +331,7 @@
     "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/TrantorConfig.cmake"
     "${CMAKE_CURRENT_BINARY_DIR}/TrantorConfigVersion.cmake"
     "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/Findc-ares.cmake"
+    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/FindBotan.cmake"
   DESTINATION "${INSTALL_TRANTOR_CMAKE_DIR}"
   COMPONENT dev)
 
@@ -286,32 +344,3 @@
 # Doxygen documentation
 find_package(Doxygen OPTIONAL_COMPONENTS dot dia)
 if(DOXYGEN_FOUND)
-  set(DOXYGEN_PROJECT_BRIEF "Non-blocking I/O cross-platform TCP network library, using C++14")
-  set(DOXYGEN_OUTPUT_DIRECTORY docs/${PROJECT_NAME})
-  set(DOXYGEN_GENERATE_LATEX NO)
-  set(DOXYGEN_BUILTIN_STL_SUPPORT YES)
-  set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)
-  set(DOXYGEN_STRIP_FROM_INC_PATH ${PROJECT_SOURCE_DIR}
-                                  ${CMAKE_CURRENT_BINARY_DIR}/exports)
-  if (WIN32)
-    set(DOXYGEN_PREDEFINED _WIN32)
-  endif(WIN32)
-  doxygen_add_docs(doc_${PROJECT_NAME}
-                   README.md
-                   ChangeLog.md
-                   ${public_net_headers}
-                   ${public_utils_headers}
-                   COMMENT "Generate documentation")
-  if(NOT TARGET doc)
-    add_custom_target(doc)
-  endif()
-  add_dependencies(doc doc_${PROJECT_NAME})
-  if (BUILD_DOC)
-    add_dependencies(${PROJECT_NAME} doc_${PROJECT_NAME})
-    # Don't install twice, so limit to Debug (assume developer)
-    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs/${PROJECT_NAME}
-            TYPE DOC
-            CONFIGURATIONS Debug)
-  endif(BUILD_DOC)
-endif(DOXYGEN_FOUND)
-
