=== trantor/tests/CMakeLists.txt ===
--- 
+++ 
@@ -17,11 +17,11 @@
 add_executable(timing_wheel_test TimingWheelTest.cc)
 add_executable(kickoff_test KickoffTest.cc)
 add_executable(dns_test DnsTest.cc)
-add_executable(delayed_ssl_server_test DelayedSSLServerTest.cc)
-add_executable(delayed_ssl_client_test DelayedSSLClientTest.cc)
 add_executable(run_on_quit_test RunOnQuitTest.cc)
 add_executable(path_conversion_test PathConversionTest.cc)
 add_executable(logger_macro_test LoggerMacroTest.cc)
+add_executable(delayed_ssl_server_test DelayedSSLServerTest.cc)
+add_executable(delayed_ssl_client_test DelayedSSLClientTest.cc)
 set(targets_list
     ssl_server_test
     ssl_client_test
@@ -42,11 +42,11 @@
     timing_wheel_test
     kickoff_test
     dns_test
-    delayed_ssl_server_test
-    delayed_ssl_client_test
     run_on_quit_test
     path_conversion_test
-    logger_macro_test)
+    logger_macro_test
+    delayed_ssl_server_test
+    delayed_ssl_client_test)
 
 set_property(TARGET ${targets_list} PROPERTY CXX_STANDARD 14)
 set_property(TARGET ${targets_list} PROPERTY CXX_STANDARD_REQUIRED ON)
