=== debian/changelog ===
trantor (1.5.12+ds-1ubuntu4) noble; urgency=medium

  * Hard-code libcares2 instead of libc-ares2.
  * Fix unparsable  build dependency. See LP #2061834.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 16 Apr 2024 15:03:51 +0200

trantor (1.5.12+ds-1ubuntu3) noble; urgency=medium

  * No-change rebuild for c-ares t64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 16 Apr 2024 11:55:33 +0200

trantor (1.5.12+ds-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:10:48 +1100

trantor (1.5.12+ds-1ubuntu1) noble; urgency=medium

  * Drop spurious Depends on libssl3 as package is currently built with no TLS
    provider.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 21 Mar 2024 15:06:24 +1300

trantor (1.5.12+ds-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:07:38 +0000

trantor (1.5.12+ds-1) unstable; urgency=medium

  * New upstream release 1.5.12+ds (Closes: #1042181)
  * Add a debian/watch file

 -- Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>  Wed, 13 Sep 2023 13:45:24 +0200
