=== debian/control ===
Source: trantor
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Pierre-Elliott Bécue <pierre-elliott.becue@gandi.net>
Section: web
Priority: optional
Build-Depends: cmake, debhelper-compat (= 13), dh-cmake, dh-cmake-compat (= 1)
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/trantor
Vcs-Git: https://salsa.debian.org/debian/trantor.git
Homepage: https://github.com/an-tao/trantor
Rules-Requires-Root: no

Package: libtrantor1
Architecture: any
Depends: libcares2, ${misc:Depends}, ${shlibs:Depends}
Description: Non-blocking I/O cross-platform TCP network library
 Trantor is a non-blocking I/O cross-platform TCP network library, using C++14.
 Drawing on the design of Muduo Library
 .
 This package provides the trantor library itself

Package: libtrantor-dev
Architecture: any
Depends: libtrantor1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Non-blocking I/O cross-platform TCP network library
 Trantor is a non-blocking I/O cross-platform TCP network library, using C++14.
 Drawing on the design of Muduo Library
 .
 This package provides the development files for the trantor library
