=== debian/changelog ===
trantor (1.5.20+ds-2) unstable; urgency=medium

  * Update hard-coded dependencies for libtrantor1 (Closes: #1079626)
    Sadly they are not dragged by shlibs:Depends mechanism.

 -- Pierre-Elliott Bécue <peb@debian.org>  Tue, 27 Aug 2024 17:54:13 +0200

trantor (1.5.20+ds-1) unstable; urgency=medium

  * New upstream release 1.5.20+ds
    (Closes: #1071725)
  * d/control:
    - Change my maintainer mail
    - Bump Standards-Version to 4.7.0
    - Relabel libtrantor-dev section
    - Fix libtrantor-dev description
    - Relabel libtrantor1 section
  * d/copyright:
    - Bump copyright and change my maintainer mail
  * d/rules:
    - Set hardening flags

 -- Pierre-Elliott Bécue <peb@debian.org>  Fri, 23 Aug 2024 16:22:35 +0200
