=== debian/changelog ===
trantor (1.5.24+ds-1) unstable; urgency=medium

  * New upstream release 1.5.24+ds
  * d/copyright bumped
  * d/control:
    - Bump Standards-Version to 4.7.2

 -- Pierre-Elliott Bécue <peb@debian.org>  Sun, 21 Sep 2025 20:16:38 +0200
