=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: web
 Priority: optional
 Build-Depends: cmake, debhelper-compat (=13), dh-cmake, dh-cmake-compat (=1)
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/trantor
 Vcs-Git: https://salsa.debian.org/debian/trantor.git
 Homepage: https://github.com/an-tao/trantor
