=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/,repacksuffix=+ds,dversionmangle=s/\+ds// \
https://github.com/an-tao/@PACKAGE@/tags \
.*[^n]/(?:|v|version-|r|REL_|rel-|(?:@PACKAGE@)(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
